#include "CBox.h"
#include <iostream>
#include <cmath>

using namespace std;

CBox::CBox(float s){
    size = s;
    num_vertices = 8;
    vertices = new float[num_vertices][3];
    vertices[0][0] = -size/2.0;
    vertices[0][1] =-size/2.0;
    vertices[0][2] = -size/2.0;
    vertices[1][0] = -size/2.0;
    vertices[1][1] = size/2.0;
    vertices[1][2] = -size/2.0;
    vertices[2][0] = size/2.0;
    vertices[2][1] = size/2.0;
    vertices[2][2] = -size/2.0;
    vertices[3][0] = size/2.0;
    vertices[3][1] = -size/2.0;
    vertices[3][2] = -size/2.0;
    vertices[4][0] = -size/2.0;
    vertices[4][1] = -size/2.0;
    vertices[4][2] = size/2.0;
    vertices[5][0] = -size/2.0;
    vertices[5][1] = size/2.0;
    vertices[5][2] = size/2.0;
    vertices[6][0] = size/2.0;
    vertices[6][1] = size/2.0;
    vertices[6][2] = size/2.0;
    vertices[7][0] = size/2.0;
    vertices[7][1] = -size/2.0;
    vertices[7][2] = size/2.0;
}

CBox::~CBox() {
    delete[] vertices;
}

void CBox::print(void){
    // complete this with size, volume, area
    for (int i = 0; i < num_vertices; i++){
        for (int j = 0; j < 3; j++){
            cout << vertices[i][j] << endl;
        }
        cout << endl;
    }
    cout << "Size: " << size << endl;
    cout << "Surface area: " << getSurfaceArea() << endl;
    cout << "Volume: " << getVolume() << endl;
}

float CBox::getSurfaceArea(void){
    return 6 * size * size;
}

float CBox::getVolume(void){
    return size * size * size;
}
